package tfc.jvilarodr.logic;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;
import tfc.jvilarodr.model.Comunidad;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@Stateless
public class ComunidadFacade extends AbstractFacade<Comunidad> implements ComunidadFacadeLocal {
    @PersistenceContext(unitName = "tfc-jpaPU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public ComunidadFacade() {
        super(Comunidad.class);
    }

    @Override
    public List<Comunidad> findAll(Object idUsuario) {
            try {
            TypedQuery<Comunidad> query = getEntityManager().createNamedQuery("Comunidad.findAll", Comunidad.class);
            query.setParameter("idUsuario", idUsuario);
            return query.getResultList();
        } catch(NoResultException e) {
            return null;
        }    
    }
    
    public List<Comunidad> findAllNotIn(Object idUsuario) {
            try {
            TypedQuery<Comunidad> query = getEntityManager().createNamedQuery("Comunidad.findAllNotIn", Comunidad.class);
            query.setParameter("idUsuario", idUsuario);
            return query.getResultList();
        } catch(NoResultException e) {
            return null;
        }    
    }
    
}
