package tfc.jvilarodr.logic;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;
import tfc.jvilarodr.model.Credenciales;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@Stateless
public class CredencialesFacade extends AbstractFacade<Credenciales> implements CredencialesFacadeLocal {
    @PersistenceContext(unitName = "tfc-jpaPU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public CredencialesFacade() {
        super(Credenciales.class);
    }
    
    @Override
    public Credenciales findBy(String cuenta) {
        try {
            TypedQuery<Credenciales> query = getEntityManager().createNamedQuery("Credenciales.findByCuenta", Credenciales.class);
            query.setParameter("cuenta", cuenta);
            return (Credenciales) query.getSingleResult();
        } catch(NoResultException e) {
            return null;
        }
    } 
        
}
