package tfc.jvilarodr.logic;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;
import tfc.jvilarodr.model.Mensaje;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@Stateless
public class MensajeFacade extends AbstractFacade<Mensaje> implements MensajeFacadeLocal {
    @PersistenceContext(unitName = "tfc-jpaPU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public MensajeFacade() {
        super(Mensaje.class);
    }
    
    @Override
    public List<Mensaje> findBy(Integer idUsuario) {
        try {
            TypedQuery<Mensaje> query = getEntityManager().createNamedQuery("Mensaje.findByIdUsuario", Mensaje.class); 
            query.setParameter("idUsuario", idUsuario);
            return  query.getResultList();
        } catch(NoResultException e) {
            return null;    
        } 
    }    

    @Override
    public List<Mensaje> findByIdComunidad(Integer idComunidad) {
        try {
            TypedQuery<Mensaje> query = getEntityManager().createNamedQuery("Mensaje.findByIdComunidad", Mensaje.class); 
            query.setParameter("idComunidad", idComunidad);
            return  query.getResultList();
        } catch(NoResultException e) {
            return null;    
        } 
    }     
}
