package tfc.jvilarodr.logic;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.*;
import tfc.jvilarodr.model.Perfil;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@Stateless
public class PerfilFacade extends AbstractFacade<Perfil> implements PerfilFacadeLocal {
    @PersistenceContext(unitName = "tfc-jpaPU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public PerfilFacade() {
        super(Perfil.class);
    }
    
    @Override
    public List<Perfil> findBy(Integer idUsuario) {
        try {
            TypedQuery<Perfil> query = getEntityManager().createNamedQuery("Perfil.findByIdUsuario", Perfil.class); 
            query.setParameter("idUsuario", idUsuario);
            return  query.getResultList();
        } catch(NoResultException e) {
            return null;    
        } 
    }
    
}
