package tfc.jvilarodr.logic;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;
import tfc.jvilarodr.model.Recurso;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@Stateless
public class RecursoFacade extends AbstractFacade<Recurso> implements RecursoFacadeLocal {
    @PersistenceContext(unitName = "tfc-jpaPU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public RecursoFacade() {
        super(Recurso.class);
    }
    
    @Override
    public List<Recurso> findBy(Integer idUsuario) {
        try {
            TypedQuery<Recurso> query = getEntityManager().createNamedQuery("Recurso.findByIdUsuario", Recurso.class); 
            query.setParameter("idUsuario", idUsuario);
            return  query.getResultList();
        } catch(NoResultException e) {
            return null;    
        } 
    }
    
}
