package tfc.jvilarodr.logic;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;
import tfc.jvilarodr.model.Relacion;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@Stateless
public class RelacionFacade extends AbstractFacade<Relacion> implements RelacionFacadeLocal {
    @PersistenceContext(unitName = "tfc-jpaPU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public RelacionFacade() {
        super(Relacion.class);
    }
    
    @Override
    public List<Relacion> findBy(Integer idUsuario) {
        try {
            TypedQuery<Relacion> query = getEntityManager().createNamedQuery("Relacion.findByIdUsuario1", Relacion.class); 
            query.setParameter("idUsuario1", idUsuario);
            return  query.getResultList();
        } catch(NoResultException e) {
            return null;    
        } 
    }
    
}
