package tfc.jvilarodr.logic;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;
import tfc.jvilarodr.model.Usuario;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@Stateless
public class UsuarioFacade extends AbstractFacade<Usuario> implements UsuarioFacadeLocal {
    @PersistenceContext(unitName = "tfc-jpaPU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public UsuarioFacade() {
        super(Usuario.class);
    }
    
    @Override
    public Usuario findBy(String email) {
        try {
            TypedQuery<Usuario> query = getEntityManager().createNamedQuery("Usuario.findByEmail", Usuario.class);
            query.setParameter("email", email);
            return (Usuario) query.getSingleResult();
        } catch(NoResultException e) {
            return null;
        }
    }
    
    @Override
    public List<Usuario> findAll(Object idUsuario) {
        try {
            TypedQuery<Usuario> query = getEntityManager().createNamedQuery("Usuario.findAll", Usuario.class);
            query.setParameter("idUsuario", idUsuario);
            return query.getResultList();
        } catch(NoResultException e) {
            return null;
        }
    }
    
    public List<Usuario> findAllNotIn(Object idUsuario) {
        try {
            TypedQuery<Usuario> query = getEntityManager().createNamedQuery("Usuario.findAllNotIn", Usuario.class);
            query.setParameter("idUsuario", idUsuario);
            return query.getResultList();
        } catch(NoResultException e) {
            return null;
        }
    }
    
}
