package tfc.jvilarodr.ws;

import java.util.List;
import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import tfc.jvilarodr.logic.ComunidadFacadeLocal;
import tfc.jvilarodr.model.Comunidad;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@WebService(serviceName = "comunidades")
@Stateless()
public class ServicioComunidad {
    @EJB
    private ComunidadFacadeLocal ejbRef;

    @WebMethod(operationName = "create")
    @Oneway
    public void create(@WebParam(name = "comunidad") Comunidad comunidad) {
        ejbRef.create(comunidad);
    }

    @WebMethod(operationName = "edit")
    @Oneway
    public void edit(@WebParam(name = "comunidad") Comunidad comunidad) {
        ejbRef.edit(comunidad);
    }

    @WebMethod(operationName = "remove")
    @Oneway
    public void remove(@WebParam(name = "comunidad") Comunidad comunidad) {
        ejbRef.remove(comunidad);
    }

    @WebMethod(operationName = "find")
    public Comunidad find(@WebParam(name = "id") Object id) {
        return ejbRef.find(id);
    }

    @WebMethod(operationName = "findAll")
    public List<Comunidad> findAll(@WebParam(name = "idUsuario") Object idUsuario) {
        return ejbRef.findAll(idUsuario);
    }

    @WebMethod(operationName = "findAllNotIn")
    public List<Comunidad> findAllNotIn(@WebParam(name = "idUsuario") Object idUsuario) {
        return ejbRef.findAllNotIn(idUsuario);
    }    
    
    @WebMethod(operationName = "findRange")
    public List<Comunidad> findRange(@WebParam(name = "range") int[] range) {
        return ejbRef.findRange(range);
    }

    @WebMethod(operationName = "count")
    public int count() {
        return ejbRef.count();
    }  
    
}
