package tfc.jvilarodr.ws;

import java.util.List;
import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import tfc.jvilarodr.logic.CredencialesFacadeLocal;
import tfc.jvilarodr.model.Credenciales;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@WebService(serviceName = "usuarios")
@Stateless()
public class ServicioCredenciales {
    @EJB
    private CredencialesFacadeLocal ejbRef;

    @WebMethod(operationName = "create")
    @Oneway
    public void create(@WebParam(name = "credenciales") Credenciales credenciales) {
        ejbRef.create(credenciales);
    }

    @WebMethod(operationName = "edit")
    @Oneway
    public void edit(@WebParam(name = "credenciales") Credenciales credenciales) {
        ejbRef.edit(credenciales);
    }

    @WebMethod(operationName = "remove")
    @Oneway
    public void remove(@WebParam(name = "credenciales") Credenciales credenciales) {
        ejbRef.remove(credenciales);
    }

    @WebMethod(operationName = "find")
    public Credenciales find(@WebParam(name = "id") Object id) {
        return ejbRef.find(id);
    }
    
    @WebMethod(operationName = "findBy")
    public Credenciales findBy(@WebParam(name = "cuenta") String cuenta) {
        return ejbRef.findBy(cuenta);
    }
       
    @WebMethod(operationName = "findAll")
    public List<Credenciales> findAll() {
        return ejbRef.findAll();
    }

    @WebMethod(operationName = "findRange")
    public List<Credenciales> findRange(@WebParam(name = "range") int[] range) {
        return ejbRef.findRange(range);
    }

    @WebMethod(operationName = "count")
    public int count() {
        return ejbRef.count();
    }
    
}
