package tfc.jvilarodr.ws;

import java.util.List;
import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import tfc.jvilarodr.logic.MensajeFacadeLocal;
import tfc.jvilarodr.model.Mensaje;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@WebService(serviceName = "comunidades")
@Stateless()
public class ServicioMensaje {
    @EJB
    private MensajeFacadeLocal ejbRef;

    @WebMethod(operationName = "create")
    @Oneway
    public void create(@WebParam(name = "mensaje") Mensaje mensaje) {
        ejbRef.create(mensaje);
    }

    @WebMethod(operationName = "edit")
    @Oneway
    public void edit(@WebParam(name = "mensaje") Mensaje mensaje) {
        ejbRef.edit(mensaje);
    }

    @WebMethod(operationName = "remove")
    @Oneway
    public void remove(@WebParam(name = "mensaje") Mensaje mensaje) {
        ejbRef.remove(mensaje);
    }

    @WebMethod(operationName = "find")
    public Mensaje find(@WebParam(name = "id") Object id) {
        return ejbRef.find(id);
    }
    
    @WebMethod(operationName = "findBy")
    public List<Mensaje> findBy(@WebParam(name = "idUsuario") Integer idUsuario) {
        return ejbRef.findBy(idUsuario);
    }

    @WebMethod(operationName = "findByIdComunidad")
    public List<Mensaje> findByIdComunidad(@WebParam(name = "idComunidad") Integer idComunidad) {
        return ejbRef.findByIdComunidad(idComunidad);
    }
    
    @WebMethod(operationName = "findAll")
    public List<Mensaje> findAll() {
        return ejbRef.findAll();
    }

    @WebMethod(operationName = "findRange")
    public List<Mensaje> findRange(@WebParam(name = "range") int[] range) {
        return ejbRef.findRange(range);
    }

    @WebMethod(operationName = "count")
    public int count() {
        return ejbRef.count();
    }
    
}
