package tfc.jvilarodr.ws;

import java.util.List;
import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import tfc.jvilarodr.logic.PerfilFacadeLocal;
import tfc.jvilarodr.model.Perfil;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@WebService(serviceName = "comunidades")
@Stateless()
public class ServicioPerfil {
    @EJB
    private PerfilFacadeLocal ejbRef;

    @WebMethod(operationName = "create")
    @Oneway
    public void create(@WebParam(name = "perfil") Perfil perfil) {
        ejbRef.create(perfil);
    }

    @WebMethod(operationName = "edit")
    @Oneway
    public void edit(@WebParam(name = "perfil") Perfil perfil) {
        ejbRef.edit(perfil);
    }

    @WebMethod(operationName = "remove")
    @Oneway
    public void remove(@WebParam(name = "perfil") Perfil perfil) {
        ejbRef.remove(perfil);
    }

    @WebMethod(operationName = "find")
    public Perfil find(@WebParam(name = "id") Object id) {
        return ejbRef.find(id);
    }
    
    @WebMethod(operationName = "findBy")
    public List<Perfil> findBy(@WebParam(name = "idUsuario") Integer idUsuario) {
        return ejbRef.findBy(idUsuario);
    }

    @WebMethod(operationName = "findAll")
    public List<Perfil> findAll() {
        return ejbRef.findAll();
    }

    @WebMethod(operationName = "findRange")
    public List<Perfil> findRange(@WebParam(name = "range") int[] range) {
        return ejbRef.findRange(range);
    }

    @WebMethod(operationName = "count")
    public int count() {
        return ejbRef.count();
    }
    
}
