package tfc.jvilarodr.ws;

import java.util.List;
import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import tfc.jvilarodr.logic.RecursoFacadeLocal;
import tfc.jvilarodr.model.Recurso;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@WebService(serviceName = "usuarios")
@Stateless()
public class ServicioRecurso {
    @EJB
    private RecursoFacadeLocal ejbRef;

    @WebMethod(operationName = "create")
    @Oneway
    public void create(@WebParam(name = "recurso") Recurso recurso) {
        ejbRef.create(recurso);
    }

    @WebMethod(operationName = "edit")
    @Oneway
    public void edit(@WebParam(name = "recurso") Recurso recurso) {
        ejbRef.edit(recurso);
    }

    @WebMethod(operationName = "remove")
    @Oneway
    public void remove(@WebParam(name = "recurso") Recurso recurso) {
        ejbRef.remove(recurso);
    }

    @WebMethod(operationName = "find")
    public Recurso find(@WebParam(name = "id") Object id) {
        return ejbRef.find(id);
    }
    
    @WebMethod(operationName = "findBy")
    public List<Recurso> findBy(@WebParam(name = "idUsuario") Integer idUsuario) {
        return ejbRef.findBy(idUsuario);
    }    

    @WebMethod(operationName = "findAll")
    public List<Recurso> findAll() {
        return ejbRef.findAll();
    }

    @WebMethod(operationName = "findRange")
    public List<Recurso> findRange(@WebParam(name = "range") int[] range) {
        return ejbRef.findRange(range);
    }

    @WebMethod(operationName = "count")
    public int count() {
        return ejbRef.count();
    }
    
}
