package tfc.jvilarodr.ws;

import java.util.List;
import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import tfc.jvilarodr.logic.RelacionFacadeLocal;
import tfc.jvilarodr.model.Relacion;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@WebService(serviceName = "usuarios")
@Stateless()
public class ServicioRelacion {
    @EJB
    private RelacionFacadeLocal ejbRef;

    @WebMethod(operationName = "create")
    @Oneway
    public void create(@WebParam(name = "relacion") Relacion relacion) {
        ejbRef.create(relacion);
    }

    @WebMethod(operationName = "edit")
    @Oneway
    public void edit(@WebParam(name = "relacion") Relacion relacion) {
        ejbRef.edit(relacion);
    }

    @WebMethod(operationName = "remove")
    @Oneway
    public void remove(@WebParam(name = "relacion") Relacion relacion) {
        ejbRef.remove(relacion);
    }

    @WebMethod(operationName = "find")
    public Relacion find(@WebParam(name = "id") Object id) {
        return ejbRef.find(id);
    }
    
    @WebMethod(operationName = "findBy")
    public List<Relacion> findBy(@WebParam(name = "idUsuario1") Integer idUsuario) {
        return ejbRef.findBy(idUsuario);
    } 

    @WebMethod(operationName = "findAll")
    public List<Relacion> findAll() {
        return ejbRef.findAll();
    }

    @WebMethod(operationName = "findRange")
    public List<Relacion> findRange(@WebParam(name = "range") int[] range) {
        return ejbRef.findRange(range);
    }

    @WebMethod(operationName = "count")
    public int count() {
        return ejbRef.count();
    }
    
}
