package tfc.jvilarodr.ws;

import java.util.List;
import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import tfc.jvilarodr.logic.UsuarioFacadeLocal;
import tfc.jvilarodr.model.Usuario;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@WebService(serviceName = "usuarios")
@Stateless()
public class ServicioUsuario {
    @EJB
    private UsuarioFacadeLocal ejbRef;

    @WebMethod(operationName = "create")
    @Oneway
    public void create(@WebParam(name = "usuario") Usuario usuario) {
        ejbRef.create(usuario);
    }

    @WebMethod(operationName = "edit")
    @Oneway
    public void edit(@WebParam(name = "usuario") Usuario usuario) {
        ejbRef.edit(usuario);
    }

    @WebMethod(operationName = "remove")
    @Oneway
    public void remove(@WebParam(name = "usuario") Usuario usuario) {
        ejbRef.remove(usuario);
    }

    @WebMethod(operationName = "find")
    public Usuario find(@WebParam(name = "id") Object id) {
        return ejbRef.find(id);
    }
    
    @WebMethod(operationName = "findBy")
    public Usuario findBy(@WebParam(name = "email") String email) {
        return ejbRef.findBy(email);
    }

    @WebMethod(operationName = "findAll")
    public List<Usuario> findAll(@WebParam(name = "id") Object id) {
        return ejbRef.findAll(id);
    }
    
    @WebMethod(operationName = "findAllNotIn")
    public List<Usuario> findAllNotIn(@WebParam(name = "id") Object id) {
        return ejbRef.findAllNotIn(id);
    }    

    @WebMethod(operationName = "findRange")
    public List<Usuario> findRange(@WebParam(name = "range") int[] range) {
        return ejbRef.findRange(range);
    }

    @WebMethod(operationName = "count")
    public int count() {
        return ejbRef.count();
    }
    
}
