package tfc.jvilarodr.model;

import java.io.Serializable;
import javax.persistence.*;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@Entity
@Table(name = "comunidad", uniqueConstraints = {
    @UniqueConstraint(columnNames = {"nombre"})})
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Comunidad.findAll", query = "SELECT c FROM Comunidad c "+
                                                    "WHERE c.idComunidad IN (SELECT p.idComunidad FROM Perfil p WHERE p.idUsuario = :idUsuario)"),
    @NamedQuery(name = "Comunidad.findAllNotIn", query = "SELECT c FROM Comunidad c "+
                                                         "WHERE c.idComunidad NOT IN (SELECT p.idComunidad FROM Perfil p WHERE p.idUsuario = :idUsuario)"),
    @NamedQuery(name = "Comunidad.findByIdComunidad", query = "SELECT c FROM Comunidad c WHERE c.idComunidad = :idComunidad"),
    @NamedQuery(name = "Comunidad.findByNombre", query = "SELECT c FROM Comunidad c WHERE c.nombre = :nombre"),
    @NamedQuery(name = "Comunidad.findByEstado", query = "SELECT c FROM Comunidad c WHERE c.estado = :estado")})
public class Comunidad implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id_comunidad", nullable = false)
    private Integer idComunidad;
    @Basic(optional = false)
    @Column(name = "nombre", nullable = false, length = 60)
    private String nombre;
    @Column(name = "estado")
    private int estado;

    public Comunidad() {
    }

    public Comunidad(Integer idComunidad) {
        this.idComunidad = idComunidad;
    }

    public Comunidad(Integer idComunidad, String nombre) {
        this.idComunidad = idComunidad;
        this.nombre = nombre;
    }

    public Integer getIdComunidad() {
        return idComunidad;
    }

    public void setIdComunidad(Integer idComunidad) {
        this.idComunidad = idComunidad;
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    public int getEstado() {
        return estado;
    }

    public void setEstado(int estado) {
        this.estado = estado;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idComunidad != null ? idComunidad.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        if (!(object instanceof Comunidad)) {
            return false;
        }
        Comunidad other = (Comunidad) object;
        if ((this.idComunidad == null && other.idComunidad != null) || (this.idComunidad != null && !this.idComunidad.equals(other.idComunidad))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "tfc.jvilarodr.model.Comunidad[ idComunidad=" + idComunidad + " ]";
    }
    
}
