package tfc.jvilarodr.model;

import java.io.Serializable;
import javax.persistence.*;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@Entity
@Table(name = "credenciales", uniqueConstraints = {
    @UniqueConstraint(columnNames = {"cuenta"})})
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Credenciales.findAll", query = "SELECT c FROM Credenciales c"),
    @NamedQuery(name = "Credenciales.findByIdCredenciales", query = "SELECT c FROM Credenciales c WHERE c.idCredenciales = :idCredenciales"),
    @NamedQuery(name = "Credenciales.findByCuenta", query = "SELECT c FROM Credenciales c WHERE c.cuenta = :cuenta"),
    @NamedQuery(name = "Credenciales.findByClave", query = "SELECT c FROM Credenciales c WHERE c.clave = :clave"),
    @NamedQuery(name = "Credenciales.findByIdUsuario", query = "SELECT c FROM Credenciales c WHERE c.idUsuario = :idUsuario"),
    @NamedQuery(name = "Credenciales.findByEstado", query = "SELECT c FROM Credenciales c WHERE c.estado = :estado")})
public class Credenciales implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id_credenciales", nullable = false)
    private Integer idCredenciales;
    @Basic(optional = false)
    @Column(name = "cuenta", nullable = false, length = 30)
    private String cuenta;
    @Basic(optional = false)
    @Column(name = "clave", nullable = false, length = 16)
    private String clave;
    @Basic(optional = false)
    @Column(name = "id_usuario", nullable = false)
    private int idUsuario;
    @Column(name = "estado")
    private int estado;

    public Credenciales() {
    }

    public Credenciales(Integer idCredenciales) {
        this.idCredenciales = idCredenciales;
    }

    public Credenciales(Integer idCredenciales, String cuenta, String clave, int idUsuario) {
        this.idCredenciales = idCredenciales;
        this.cuenta = cuenta;
        this.clave = clave;
        this.idUsuario = idUsuario;
    }

    public Integer getIdCredenciales() {
        return idCredenciales;
    }

    public void setIdCredenciales(Integer idCredenciales) {
        this.idCredenciales = idCredenciales;
    }

    public String getCuenta() {
        return cuenta;
    }

    public void setCuenta(String cuenta) {
        this.cuenta = cuenta;
    }

    public String getClave() {
        return clave;
    }

    public void setClave(String clave) {
        this.clave = clave;
    }

    public int getIdUsuario() {
        return idUsuario;
    }

    public void setIdUsuario(int idUsuario) {
        this.idUsuario = idUsuario;
    }

    public int getEstado() {
        return estado;
    }

    public void setEstado(int estado) {
        this.estado = estado;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idCredenciales != null ? idCredenciales.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        if (!(object instanceof Credenciales)) {
            return false;
        }
        Credenciales other = (Credenciales) object;
        if ((this.idCredenciales == null && other.idCredenciales != null) || (this.idCredenciales != null && !this.idCredenciales.equals(other.idCredenciales))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "tfc.jvilarodr.model.Credenciales[ idCredenciales=" + idCredenciales + " ]";
    }
    
}
