package tfc.jvilarodr.model;

import java.io.Serializable;
import javax.persistence.*;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@Entity
@Table(name = "mensaje")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Mensaje.findAll", query = "SELECT m FROM Mensaje m"),
    @NamedQuery(name = "Mensaje.findByIdMensaje", query = "SELECT m FROM Mensaje m WHERE m.idMensaje = :idMensaje"),
    @NamedQuery(name = "Mensaje.findByTexto", query = "SELECT m FROM Mensaje m WHERE m.texto = :texto"),
    @NamedQuery(name = "Mensaje.findByIdMensajeOriginal", query = "SELECT m FROM Mensaje m WHERE m.idMensajeOriginal = :idMensajeOriginal"),
    @NamedQuery(name = "Mensaje.findByIdUsuario", query = "SELECT m FROM Mensaje m WHERE m.idUsuario = :idUsuario"),
    @NamedQuery(name = "Mensaje.findByIdComunidad", query = "SELECT m FROM Mensaje m WHERE m.idComunidad = :idComunidad"),
    @NamedQuery(name = "Mensaje.findByEstado", query = "SELECT m FROM Mensaje m WHERE m.estado = :estado")})
public class Mensaje implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id_mensaje", nullable = false)
    private Integer idMensaje;
    @Basic(optional = false)
    @Column(name = "texto", nullable = false, length = 200)
    private String texto;
    @Basic(optional = false)
    @Column(name = "id_mensaje_original", nullable = false)
    private int idMensajeOriginal;
    @Basic(optional = false)
    @Column(name = "id_usuario", nullable = false)
    private int idUsuario;
    @Basic(optional = false)
    @Column(name = "id_comunidad", nullable = false)
    private int idComunidad;
    @Column(name = "estado")
    private int estado;

    public Mensaje() {
    }

    public Mensaje(Integer idMensaje) {
        this.idMensaje = idMensaje;
    }

    public Mensaje(Integer idMensaje, String texto, int idMensajeOriginal, int idUsuario, int idComunidad) {
        this.idMensaje = idMensaje;
        this.texto = texto;
        this.idMensajeOriginal = idMensajeOriginal;
        this.idUsuario = idUsuario;
        this.idComunidad = idComunidad;
    }

    public Integer getIdMensaje() {
        return idMensaje;
    }

    public void setIdMensaje(Integer idMensaje) {
        this.idMensaje = idMensaje;
    }

    public String getTexto() {
        return texto;
    }

    public void setTexto(String texto) {
        this.texto = texto;
    }

    public int getIdMensajeOriginal() {
        return idMensajeOriginal;
    }

    public void setIdMensajeOriginal(int idMensajeOriginal) {
        this.idMensajeOriginal = idMensajeOriginal;
    }

    public int getIdUsuario() {
        return idUsuario;
    }

    public void setIdUsuario(int idUsuario) {
        this.idUsuario = idUsuario;
    }

    public int getIdComunidad() {
        return idComunidad;
    }

    public void setIdComunidad(int idComunidad) {
        this.idComunidad = idComunidad;
    }

    public int getEstado() {
        return estado;
    }

    public void setEstado(int estado) {
        this.estado = estado;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idMensaje != null ? idMensaje.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        if (!(object instanceof Mensaje)) {
            return false;
        }
        Mensaje other = (Mensaje) object;
        if ((this.idMensaje == null && other.idMensaje != null) || (this.idMensaje != null && !this.idMensaje.equals(other.idMensaje))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "tfc.jvilarodr.model.Mensaje[ idMensaje=" + idMensaje + " ]";
    }
    
}
