package tfc.jvilarodr.model;

import java.io.Serializable;
import javax.persistence.*;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@Entity
@Table(name = "relacion")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Relacion.findAll", query = "SELECT r FROM Relacion r"),
    @NamedQuery(name = "Relacion.findByIdRelacion", query = "SELECT r FROM Relacion r WHERE r.idRelacion = :idRelacion"),
    @NamedQuery(name = "Relacion.findByRol", query = "SELECT r FROM Relacion r WHERE r.rol = :rol"),
    @NamedQuery(name = "Relacion.findByInvitacion", query = "SELECT r FROM Relacion r WHERE r.invitacion = :invitacion"),
    @NamedQuery(name = "Relacion.findByIdUsuario1", query = "SELECT r FROM Relacion r WHERE r.idUsuario1 = :idUsuario1"),
    @NamedQuery(name = "Relacion.findByIdUsuario2", query = "SELECT r FROM Relacion r WHERE r.idUsuario2 = :idUsuario2"),
    @NamedQuery(name = "Relacion.findByEstado", query = "SELECT r FROM Relacion r WHERE r.estado = :estado")})
public class Relacion implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id_relacion", nullable = false)
    private Integer idRelacion;
    @Basic(optional = false)
    @Column(name = "rol", nullable = false, length = 20)
    private String rol;
    @Column(name = "invitacion")
    private int invitacion;
    @Basic(optional = false)
    @Column(name = "id_usuario_1", nullable = false)
    private int idUsuario1;
    @Basic(optional = false)
    @Column(name = "id_usuario_2", nullable = false)
    private int idUsuario2;
    @Column(name = "estado")
    private int estado;

    public Relacion() {
    }

    public Relacion(Integer idRelacion) {
        this.idRelacion = idRelacion;
    }

    public Relacion(Integer idRelacion, String rol, int idUsuario1, int idUsuario2) {
        this.idRelacion = idRelacion;
        this.rol = rol;
        this.idUsuario1 = idUsuario1;
        this.idUsuario2 = idUsuario2;
    }

    public Integer getIdRelacion() {
        return idRelacion;
    }

    public void setIdRelacion(Integer idRelacion) {
        this.idRelacion = idRelacion;
    }

    public String getRol() {
        return rol;
    }

    public void setRol(String rol) {
        this.rol = rol;
    }

    public int getInvitacion() {
        return invitacion;
    }

    public void setInvitacion(int invitacion) {
        this.invitacion = invitacion;
    }

    public int getIdUsuario1() {
        return idUsuario1;
    }

    public void setIdUsuario1(int idUsuario1) {
        this.idUsuario1 = idUsuario1;
    }

    public int getIdUsuario2() {
        return idUsuario2;
    }

    public void setIdUsuario2(int idUsuario2) {
        this.idUsuario2 = idUsuario2;
    }

    public int getEstado() {
        return estado;
    }

    public void setEstado(int estado) {
        this.estado = estado;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idRelacion != null ? idRelacion.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        if (!(object instanceof Relacion)) {
            return false;
        }
        Relacion other = (Relacion) object;
        if ((this.idRelacion == null && other.idRelacion != null) || (this.idRelacion != null && !this.idRelacion.equals(other.idRelacion))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "tfc.jvilarodr.model.Relacion[ idRelacion=" + idRelacion + " ]";
    }
    
}
