package components;

import java.util.Map;
import javax.el.ELContext;
import javax.el.ELResolver;
import javax.el.PropertyNotFoundException;
import javax.faces.application.FacesMessage;
import javax.faces.component.UIInput;
import javax.faces.component.UINamingContainer;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
public class loginPanel extends UINamingContainer {
    private UIInput cuenta;
    private UIInput clave;
    private String action;

    public UIInput getClave() {
        return clave;
    }

    public void setClave(UIInput clave) {
        this.clave = clave;        
    }

    public UIInput getCuenta() {
        return cuenta;
    }

    public void setCuenta(UIInput cuenta) {
        this.cuenta = cuenta;
    }

    public String action() {
        return action;
    }

    public void actionListener(ActionEvent e) {
        FacesContext context = FacesContext.getCurrentInstance();
        FacesMessage message = null;
        ELContext elContext = context.getELContext();
        ELResolver resolver = elContext.getELResolver();
        Map<String, Object> attrs = this.getAttributes();
        Class paramTypes[] = { String.class };
        Object params[] = new Object[1];
        boolean cuentaEsValida, claveEsValida;   

        Object model = attrs.get("model");
        params[0] = getCuenta().getValue();
        cuentaEsValida = (Boolean) resolver.invoke(elContext, model, 
                "cuentaEsValida", paramTypes, params);

        try {
            action = (String) resolver.getValue(elContext, model,
                    "salidaFallo");
        } catch (PropertyNotFoundException pnfe) {
            action = null;
        }

        if (!cuentaEsValida) {
            System.out.println("DEBUG: loginPanel.actionListener = NO cuentaEsValida");
            message = new FacesMessage("Cuenta " + params[0].toString() + 
                    " no encontrada.");
            context.addMessage(getCuenta().getClientId(context), message);
        } else {
            params[0] = getClave().getValue();
            System.out.println("DEBUG: loginPanel.actionListener.params[0]=getClave():"+params[0]);
            claveEsValida = (Boolean) resolver.invoke(elContext, model,
                    "claveEsValida", paramTypes, params);
            if (!claveEsValida) {
                System.out.println("DEBUG: loginPanel.actionListener = NO claveEsValida");
                message = new FacesMessage("La clave de " +
                        (String) getCuenta().getValue() + " es incorrecta.");
                context.addMessage(clave.getClientId(context), message);
            } else {
                System.out.println("DEBUG: loginPanel.actionListener = salidaExito");
                action = (String) resolver.getValue(elContext, model,
                        "salidaExito");
            }
        }
    }

}
