package tfc.jvilarodr.logic;

import java.util.Map;
import javax.faces.bean.ApplicationScoped;
import javax.faces.bean.ManagedBean;
import javax.faces.context.FacesContext;
import javax.xml.ws.WebServiceRef;
import tfc.jvilarodr.logic.exceptions.AccesoException;
import tfc.jvilarodr.ws.usuarios.ServicioCredenciales.Credenciales;
import tfc.jvilarodr.ws.usuarios.ServicioCredenciales.ServicioCredenciales;
import tfc.jvilarodr.ws.usuarios.ServicioCredenciales.Usuarios;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */

@ManagedBean(eager = true)
@ApplicationScoped
public class AccesoCredenciales {
    @WebServiceRef(wsdlLocation = "WEB-INF/wsdl/localhost_8080/tfc-ejb/usuarios/ServicioCredenciales.wsdl")
    private Usuarios service;
        
    public static AccesoCredenciales getCurrentInstance() {
        AccesoCredenciales result = null;
        Map<String, Object> appMap = FacesContext.getCurrentInstance().
                getExternalContext().getApplicationMap();
        result = (AccesoCredenciales) appMap.get("accesoCredenciales");
        assert(null != result);

        return result;
    }

    public void registrar(final Credenciales paraCrear) throws AccesoException {
        create(paraCrear);
    }
    
    public void actualizar(final Credenciales paraActualizar) throws AccesoException {
        edit(paraActualizar);
    }    

    public Credenciales encontrar(java.lang.Object id) {
        return find(id);
    } 
    
    public Credenciales encontrarPorCuenta(String cuenta) {
        return findBy(cuenta);
    }    

    private void create(Credenciales credenciales) {
        ServicioCredenciales port = service.getServicioCredencialesPort();
        port.create(credenciales);
    } 

    private Credenciales find(java.lang.Object id) {
        ServicioCredenciales port = service.getServicioCredencialesPort();
        return port.find(id); 
    }

    private Credenciales findBy(String cuenta) {
        ServicioCredenciales port = service.getServicioCredencialesPort();
        return port.findBy(cuenta);
    }

    private void edit(Credenciales credenciales) {
        ServicioCredenciales port = service.getServicioCredencialesPort();
        port.edit(credenciales); 
    }
}

