package tfc.jvilarodr.view;

import java.util.Map;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;
import javax.faces.context.Flash;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@RequestScoped
public abstract class AbstractServicio<T> {

    @ManagedProperty(value="#{facesContext}")
    private FacesContext facesContext;

    @ManagedProperty(value="#{requestScope}")
    private Map<String, Object> requestMap;

    @ManagedProperty(value="#{sessionScope}")
    private Map<String, Object> sessionMap;

    public T getCurrentUser() {
        return (T) getSessionMap().get("cuentaActual");
    }

    public void setCurrentUser(T currentUser) {
        getSessionMap().remove("cuentaActual");
        if (null != currentUser) {
            getSessionMap().put("cuentaActual", currentUser);
        }
    }

    public boolean isUserLoggedIn() {
        return getSessionMap().containsKey("cuentaActual");
    }

    public FacesContext getFacesContext() {
        return facesContext;
    }

    public void setFacesContext(FacesContext context) {
        this.facesContext = context;
    }

    public Map<String, Object> getSessionMap() {
        return sessionMap;
    }

    public void setSessionMap(Map<String, Object> sessionMap) {
        this.sessionMap = sessionMap;
    }

    public Map<String, Object> getRequestMap() {
        return requestMap;
    }

    public void setRequestMap(Map<String, Object> requestMap) {
        this.requestMap = requestMap;
    }

    public Flash getFlash() {
        return getFacesContext().getExternalContext().getFlash();
    }

}
