package tfc.jvilarodr.view;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import tfc.jvilarodr.logic.AccesoComunidad;
import tfc.jvilarodr.logic.exceptions.AccesoException;
import tfc.jvilarodr.ws.comunidades.ServicioMensaje.Mensaje;
import tfc.jvilarodr.ws.usuarios.ServicioCredenciales.Credenciales;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@ManagedBean(name="mensajes")
@RequestScoped
public class ServicioMensajes extends AbstractServicio<Credenciales> implements Serializable {
    
    private static final long serialVersionUID = 1L; 
    
    private static final ArrayList<ServicioMensajes.Item> listaMensajes = new ArrayList<ServicioMensajes.Item>();
    private Mensaje nuevoMensaje = new Mensaje();
    private int idComunidadActual, idMensajeActual;
    private boolean insertando = false;
    
    public void encontrarMensajes() {
        if (listaMensajes.isEmpty()) {
            for(Mensaje mensaje : AccesoComunidad.getCurrentInstance().encontrarMensajes(getCurrentUser().getIdUsuario())) {
                ServicioMensajes.Item item = new ServicioMensajes.Item(mensaje);
                listaMensajes.add(item);
            }
        }
    }
   
    public ArrayList<ServicioMensajes.Item> getListaMensajes() {
        return listaMensajes;
    }
    
    public String responder(ServicioMensajes.Item item) {
        activarInsertando();
        idMensajeActual = item.getMensaje().getIdMensaje();
        idComunidadActual = item.getMensaje().getIdComunidad();
        
        return null;       
    }
  
    public String registrar() {
        setInsertando(false);

        int idUsuario = getCurrentUser().getIdUsuario();
        if(idUsuario != 0) {
            try {
                getNuevoMensaje().setIdUsuario(idUsuario); 
                getNuevoMensaje().setIdComunidad(idComunidadActual); 
                getNuevoMensaje().setIdMensajeOriginal(idMensajeActual); 
                AccesoComunidad.getCurrentInstance().registrarMensaje(getNuevoMensaje()); 
                listaMensajes.clear();
            } catch (AccesoException ex) {
                Logger.getLogger(ServicioUsuarios.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        return null;        
    }     
    
    public void activarInsertando() {
        setInsertando(true);
    }
    
    public boolean isInsertando() {
        return insertando;
    }
    
    public void setInsertando(boolean insertando) {
        this.insertando = insertando;
    }
    
    public Mensaje getNuevoMensaje() {
        return nuevoMensaje;
    }
    
    public void setNuevoMensaje(Mensaje mensaje) {
        nuevoMensaje = mensaje;
    }
    
    public static class Item {
		
        Mensaje mensaje;
        boolean editable;       
        
        public Item(Mensaje mensaje) {
                this.mensaje = mensaje;
                this.editable = false;
        }

        public Mensaje getMensaje() {
            return mensaje;
        }

        public void setMensaje(Mensaje mensaje) {
            this.mensaje = mensaje;
        }

        public boolean isEditable() {
                return editable;
        }

        public void setEditable(boolean editable) {
                this.editable = editable;
        }        
    }         
}
