package tfc.jvilarodr.view;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.event.ComponentSystemEvent;
import javax.faces.validator.ValidatorException;
import tfc.jvilarodr.logic.AccesoCredenciales;
import tfc.jvilarodr.logic.exceptions.AccesoException;
import tfc.jvilarodr.ws.usuarios.ServicioCredenciales.Credenciales;

/**
 * @author jvilarodr@uoc.edu
 * @version tfc
 * @since 18/06/2012
 */
@ManagedBean(name="presentacion") 
@RequestScoped
public class ServicioPresentacion extends AbstractServicio<Credenciales> { 
    
    private static final long serialVersionUID = 1L;
        
    private Credenciales credencialesSinAutenticar;
    private Object clave1;
        
    public ServicioPresentacion() {
    } 
            
    public boolean cuentaEsValida(String cuenta) {
        boolean result;                
        result = null != (credencialesSinAutenticar = (Credenciales) AccesoCredenciales.getCurrentInstance().encontrarPorCuenta(cuenta));
        return result;
    }

    public boolean claveEsValida(String toTest) {
        boolean result = false;
        if (null != credencialesSinAutenticar) {
            String userPassword = credencialesSinAutenticar.getClave();
            if (null != userPassword && userPassword.equals(toTest)) {
                setCurrentUser(credencialesSinAutenticar);
                result = true;
            }
        }
        credencialesSinAutenticar = null;
        return result;
    }

    public String getSalidaExito() {
        return "/index?faces-redirect=true";        
    }

    public void forwardToMainIfLoggedIn(ComponentSystemEvent cse) {
        if (isUserLoggedIn()) {
            getFacesContext().getApplication().getNavigationHandler().
                    handleNavigation(getFacesContext(), null, "/index?faces-redirect=true");
        }
    }

    public void forwardToLoginIfNotLoggedIn(ComponentSystemEvent cse) {
        String viewId = getFacesContext().getViewRoot().getViewId();
        if (!isUserLoggedIn() && !viewId.startsWith("/login") &&
            !viewId.startsWith("/register")) {
            getFacesContext().getApplication().getNavigationHandler().
                    handleNavigation(getFacesContext(), null, "/login?faces-redirect=true");
        }
    }

    public String performLogout() {
        String result = "/login?faces-redirect=true";
        setCurrentUser(null);
        getFacesContext().getExternalContext().invalidateSession();
        return result;
    }
  
    public void validaCuenta(FacesContext context, UIComponent component,
            Object cuenta) throws ValidatorException {
        if (cuentaEsValida((String) cuenta)) {
            throw new ValidatorException(new FacesMessage("La cuenta ya existe."));
        }
    }
    
    public void validaClave1(FacesContext context, UIComponent component,
            Object clave1) throws ValidatorException {
        this.clave1 = clave1;
    }

    public void validaClave2(FacesContext context, UIComponent component,
            Object clave2) throws ValidatorException {
        if (!(clave1.equals(clave2))) {
            throw new ValidatorException(new FacesMessage("Las claves tienen que coincidir."));
        }
    }

    public String registrar() {
        String result = null;
        Credenciales credenciales = new Credenciales();
        credenciales.setCuenta((String) getRequestMap().get("cuenta"));
        credenciales.setClave((String) getRequestMap().get("clave1"));
        try {
            AccesoCredenciales.getCurrentInstance().registrar(credenciales);
            setCurrentUser(credenciales);
            result = "index?faces-redirect=true";
        } catch (AccesoException ex) {
            getFacesContext().addMessage(null,
                    new FacesMessage("Error al registrar " +
                    ((null != credenciales) ? " " + credenciales.toString() : "") + "."));

        }
        return result;
    }  
    
}

